#ifndef com_h_INCLUDED
#define com_h_INCLUDED

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

DWORD dwWritten;

DCB dcb;
COMMTIMEOUTS commtimeouts;

DWORD commerr;
COMSTAT comstat;
DWORD bytes_read;

void com_putc(char c, HANDLE *hComm)
{
     if( !WriteFile(*hComm, &c, sizeof(c), &dwWritten, 0) ) printf("serial port write failed\n");
}
////
char com_getc(char *com_inputc, HANDLE hComm)
{
     ClearCommError(hComm, &commerr, &comstat);
     if(comstat.cbInQue != 0 && ReadFile(hComm, com_inputc, 1, &bytes_read, NULL) != 0) return TRUE;
     else return FALSE;
}
////
void Fehlerausgabe(char fehlercode)
{
    printf("Fehlercode: %i", fehlercode);      
    MessageBox(NULL,"Fehler","Error!", MB_ICONEXCLAMATION | MB_SETFOREGROUND | MB_OK); 
    exit(0);
}
//----------------------------------------------------------------------
void ini_com(float baudrate, HANDLE *pComm)
{
   // Port geffnet?
   if(pComm == INVALID_HANDLE_VALUE)
   { 
        MessageBox(NULL,"COM Port schon geffnet.\nSchlieen Sie alle Programme die auf den COM Port zugreifen.","Fehler!",
         MB_ICONEXCLAMATION | MB_SETFOREGROUND | MB_OK); 
        exit(0);
   }
   // IO-Buffer setzen
   if(SetupComm(*pComm, 2048, 2048) == FALSE) 
   { 
        MessageBox(NULL,"COM Port konnte nicht erstellt werden.\nPrfen Sie ob der COM Port im Gertemanager vorhanden ist.",
         "Fehler!", MB_ICONEXCLAMATION | MB_SETFOREGROUND | MB_OK); 
        exit(0);
   }
   // COM-Port einstellen
   if(GetCommState(*pComm, &dcb) == FALSE)
   { 
        MessageBox(NULL,"COM Port konnte nicht Eingestellt werden","Fehler!", MB_ICONEXCLAMATION | MB_SETFOREGROUND | MB_OK); 
        exit(0);
    }
    
   dcb.BaudRate =  baudrate;                // current baud rate
   dcb.fParity = FALSE;                     // enable parity checking
   dcb.fOutxCtsFlow = FALSE;                // Bestimmt, ob der Ausgabehandshake, der das CTS (Clear To Send)-Signal verwendet, ein- oder ausgeschaltet ist.
   dcb.fOutxDsrFlow = FALSE;                // Bestimmt, ob der Ausgabehandshake, der das DSR (Data Set Ready)-Signal verwendet, ein- oder ausgeschaltet ist.
   dcb.fDtrControl = DTR_CONTROL_ENABLE;    // Bestimmt, ob das DTR (Data Terminal Ready)-Signal ein, aus oder auf Handshake (hs) bzw. umschaltbar (tg) ist.
   dcb.fDsrSensitivity = FALSE;             // DSR sensitivity
   dcb.fTXContinueOnXoff = FALSE;           // XOFF continues Tx
   dcb.fOutX = FALSE;                       // XON/XOFF out flow control
   dcb.fInX = FALSE;                        // XON/XOFF in flow control
   dcb.fErrorChar = FALSE;                  // enable error replacement
   dcb.fNull = FALSE;                       // enable null stripping
   dcb.fRtsControl = RTS_CONTROL_ENABLE;    // RTS flow control
   dcb.fAbortOnError = FALSE;               // abort reads/writes on error
   // dcb.fDummy2 = fDummy2;                // reserved
   // dcb.wReserved = wReserved;            // not currently used
   dcb.XonLim = 0;                          // transmit XON threshold
   dcb.XoffLim = 0;                         // transmit XOFF threshold
   dcb.ByteSize = 8;                        // number of bits/byte, 4-8
   dcb.Parity = NOPARITY;                   // 0-4=no,odd,even,mark,space
   dcb.StopBits = ONESTOPBIT;               // value 0,1,2 = 1, 1.5, 2 stop bits
   dcb.XonChar = 0;                         // Tx and Rx XON character
   dcb.XoffChar = 0;                        // Tx and Rx XOFF character
   dcb.ErrorChar = 0;                       // error replacement character
   dcb.EofChar = 0;                         // end of input character
   dcb.EvtChar = 0;                         // received event character 
   dcb.fBinary = TRUE;                      // binary mode, no EOF check
   
   if(SetCommState(*pComm, &dcb) == FALSE) Fehlerausgabe(1);
   
   memset(&commtimeouts, 0, sizeof(COMMTIMEOUTS));                                  // Timout setzen
   if(SetCommTimeouts(*pComm, &commtimeouts) == FALSE) Fehlerausgabe(2);   
   dcb.fBinary = TRUE;                                                              // binary mode, no EOF check   
   PurgeComm(pComm, PURGE_RXABORT | PURGE_TXABORT | PURGE_RXCLEAR | PURGE_TXCLEAR); // IO-Buffer leeren
}
#endif
